#include "lib:uisentry.h"
#include "lib:uisusrdef.h"
#include "lib:stdio.h"

#define TRUE 1
#define FALSE 0

/* name the remote globals */
globalref short (*destbitsptr)[];
globalref int vtdx, vtdy, vtw, vth, destw, desth;

/*
 *  define the static variables
 */
int vd_id, wd_id, kb_id, x_size, y_size, key, cursor, new_abs_x, new_abs_y,
	new_width, new_height, new_wc_x1, new_wc_y1, new_wc_x2, new_wc_y2;
float fx1, fy1, fx2, fy2;

/*
 *  gain or lose kb AST
 */
gain_kb_ast( yes )
int yes;
    {
    if( yes )
	{
	uis$set_pointer_pattern( &vd_id, &wd_id, cursor, 0, &0, &15,
		0, 0, 0, 0 );
	uis$pop_viewport( &wd_id );
	}
    else
	uis$set_pointer_pattern( &vd_id, &wd_id );
    }

/*
 *  kb AST routine
 */
kb_ast( )
    {
    pushb( key & 65535, 1 );
    pushb( key & 65535, 0 );
    }

/*
 *  button AST routine
 */
button_ast( )
    {
    if( uis$test_kb( &kb_id ) )
	pushb( ( key & 65535 ) - 272, key < 0 );
    else if( ( key < 0 ) && ( ( key & 65535 ) == 400 ) )
	uis$enable_kb( &kb_id, &wd_id );
    }

/*
 *  pointer AST routine
 */
pointer_ast( )
    {
    float x, y;

    if( uis$test_kb( &kb_id ) )
	if( uis$get_pointer_position( &vd_id, &wd_id, &x, &y ) )
	    putmouse( ( int ) x, ( int ) -y );
    }

/*
 *  resize AST routine
 */
resize_ast( )
    {
    float fx1, fy1, fx2, fy2;

    fx1 = 0.;
    fy1 = -y_size;
    fx2 = x_size;
    fy2 = 0.;
    uis$resize_window( &vd_id, &wd_id, &new_abs_x, &new_abs_y,
	    &new_width, &new_height, &new_wc_x1, &new_wc_y1,
	    &new_wc_x2, &new_wc_y2 );
    uis$set_button_ast( &vd_id, &wd_id, &button_ast, &0, &key, 0, 0, 0, 0 );
    uis$set_pointer_ast( &vd_id, &wd_id, &pointer_ast, &0, 0, 0, 0, 0, 0, 0 );
    uis$set_writing_mode( &vd_id, &0, &1, &UIS$C_MODE_REPL );
    uis$image( &vd_id, &1, &fx1, &fy1, &fx2, &fy2, &destw, &desth, &1,
	    destbitsptr );
    }

/*
 *  initialize the VS-II display
 */
initdisplay( )
    {
    int sys$workstation[2], smalltalk_80[2];
    float w, h, x_res, y_res;

    x_size = 1088;
    y_size = 864;
    fx1 = 0.;
    fy1 = -y_size;
    fx2 = x_size;
    fy2 = 0.;
    sys$workstation[1] = "SYS$WORKSTATION";
    sys$workstation[0] = strlen( sys$workstation[1] );
    smalltalk_80[1] = "Smalltalk-80";
    smalltalk_80[0] = strlen( smalltalk_80[1] );
    uis$get_display_size( sys$workstation, &w, &h, &x_res, &y_res );
    w = x_size / x_res;
    h = y_size / y_res;
    vd_id = uis$create_display( &fx1, &fy1, &fx2, &fy2, &w, &h );
    wd_id = uis$create_window( &vd_id, sys$workstation, smalltalk_80,
	    &0., &-512., &512., &0., 0, 0 );
    kb_id = uis$create_kb( sys$workstation );
    uis$disable_display_list( &vd_id );
    uis$enable_viewport_kb( &kb_id, &wd_id );
    uis$set_gain_kb_ast( &kb_id, &gain_kb_ast, &1 );
    uis$set_lose_kb_ast( &kb_id, &gain_kb_ast, &0 );
    uis$set_kb_ast( &kb_id, &kb_ast, &0, &key );
    uis$set_button_ast( &vd_id, &wd_id, &button_ast, &0, &key, 0, 0, 0, 0 );
    uis$set_pointer_ast( &vd_id, &wd_id, &pointer_ast, &0, 0, 0, 0, 0, 0, 0 );
    uis$set_resize_ast( &vd_id, &wd_id, &resize_ast, &0, &new_abs_x,
	    &new_abs_y, &new_width, &new_height, &new_wc_x1, &new_wc_y1,
	    &new_wc_x2, &new_wc_y2 );
/*
    uis$delete_kb( &kb_id );
    uis$delete_window( &wd_id );
    uis$delete_display( &vd_id );
*/
    }

/*
 *  shadow a bitblt operation
 */
shadowbb( )
    {
    float x1, y1, x2, y2;

    if( vtw <= 0 || vth <= 0 )
	return;
    x1 = vtdx - 1;
    y1 = -vtdy - vth - 1;
    x2 = vtdx + vtw + 1;
    y2 = -vtdy + 1;
    uis$set_clip( &vd_id, &0, &1, &x1, &y1, &x2, &y2 );
    uis$set_writing_mode( &vd_id, &1, &2, &UIS$C_MODE_REPL );
    uis$image( &vd_id, &2, &fx1, &fy1, &fx2, &fy2, &destw, &desth, &1,
	    destbitsptr );
    }

/*
 *  loads the cursor bitmap
 */
loadcursor(bitmap)
short (*bitmap)[];
    {
    cursor = bitmap;
    if( uis$test_kb( &kb_id ) )
	uis$set_pointer_pattern( &vd_id, &wd_id, cursor, 0, &0, &15,
		0, 0, 0, 0 );
    }

/*
 *  update the cursor position
 */
updatecursor( x, y )
int x, y;
    {
    float x1, y1;

    x1 = x;
    y1 = y;
    uis$pop_viewport( &wd_id );
    uis$set_pointer_position( &vd_id, &wd_id, &x1, &y1 );
    }
